/*

	ElectrEm (c) 2000 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	fs/Microsoft/msplatfs.cpp
	=========================

	Converts internal format filenames to correct filenames as interpretted
	on a Microsoft OS (i.e. Windows or DOS)

*/
#include "../../targets.h"

#if defined(TRG_FILE_WIN32) || defined(TRG_FILE_POSIX_D)

#ifdef TRG_FILE_WIN32
#include <windows.h>
#endif

#include "../fs.h"
#include <string.h>
#include <malloc.h>

void RollLeft(char *string)
{
	while(*string)
	{
		*string = *(string+1);
		string++;
	}
}

char *C_FSAccess::GetTrueName(char *name)
{
	char tmp[3];
	char *t = NULL, *p, *str, *strfr;

	strfr = str = strdup(name);

	/* .'s are ignored when they are the first letter of a directory or filename */
	if(*str == '.') str++;
	p = str;
	while(*p)
	{
		while(*p && *p != '/')
			p++;

		if(*p == '/') p++;
		if(*p == '.') RollLeft(p);
	}

	/* '~/' is used on Microsoft platforms to refer to the directory with the executable in it */
	if(strlen(str) > 1)
	{
		memcpy(tmp, str, 2); tmp[2] = '\0';

		if(!strcmp(tmp, "~/"))
		{
#ifdef TRG_FILE_POSIX_D
			str += 2;
#else
			char *path = GetCommandLine(), *parser;
			parser = path+1;
			while(*parser != '"') parser++;
			while(*parser != '\\') parser--;

			t = (char *)malloc(parser-path+strlen(str)-1);
			memcpy(t, path+1, parser-path);
			sprintf(t+(parser-path), "%s", str+2);

			free(strfr); strfr = str = t;
#endif
		}
	}

	/* the /<drive>:/ directory form needs the first / removed to get the MS drive/path form */
	if(strlen(str) > 2)
	{
		if(*str == '/' && str[2] == ':')
			str++;
	}

	char *ret = strdup(str);
	free(strfr);
	return ret;
}

#endif