/*

	ElectrEm (c) 2000 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for details

	gfx/GGI/platbitmap.cpp
	======================

	This file makes up platform specific parts of my 'bitmap' class for
	libGGI.

*/
#include "../../targets.h"

#ifdef TRG_GFX_GGI

#include "../gfx.h"
#include <malloc.h>

bool C_bitmap::Destroy(void)
{
	if(surface)
	{
		free(surface);
		surface = NULL;
	}

	return false;
}

bool C_bitmap::PlatformCreate(C_gfx_api *apiref, int w, int h, DSPSTRUCT intended, int pal)
{
	surface = (unsigned __int8 *)malloc(w*h);
	pitch = w;

	return true;
}

void C_bitmap::Blit(void) // blits to the 'centre' of the screen, or stretches as appropriate
{
/*	if(slevel >= rslevel)
	{
		// stretch blit
	}
	else
	{*/
		int c, pos;
		/* regular blit */

		c = height;
		pos = height*width;
		while(c--)
		{
			pos -= width;
			ggiPutHLine(api->mode, tx, ty+c, width, &surface[pos]);
		}

		ggiFlush(api->mode);
//	}
}

bool C_bitmap::BeginDraw(void)
{
	return true;
}

bool C_bitmap::BeginRead(void)
{
	return true;
}

void C_bitmap::EndOperation(void)
{
}

unsigned __int8 *C_bitmap::GetLinePtr(int y)
{
	return surface + (y*pitch);
}

void C_bitmap::ReleaseLinePtr(void)
{
}

unsigned __int8 *C_bitmap::GetDLinePtr(int y)
{
	return surface + (y*pitch);
}

void C_bitmap::ReleaseDLinePtr(void)
{
}

#endif
