/*

	ElectrEm (c) 2000/1 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	gfx/null/platbitmap.cpp
	========================

	This is the NULL graphics driver. This file acts both as a useful starter
	for and as documentation for what needs to be done when start a new port

*/

#include "../../targets.h"
#ifdef TRG_GFX_NULL

#include "../gfx.h"

/*

causes a C_bitmap to clean up after itself, returning resources to
the system, etc

theoretically returns true on success false on failure, but the result isn't
checked at this time

*/
bool C_bitmap::Destroy(void)
{
	return true;
}

/*

this is a call to generate a new bitmap, of size w and h which is to be used
by the C_gfx_api pointed to, on the display described in DSPSTRUCT.

returns true on success, false on failure

*/
bool C_bitmap::PlatformCreate(C_gfx_api *apiref, int w, int h, DSPSTRUCT intended)
{
	return true;
}

/*

this procuedure acts to copy the bitmap to the screen, and has to perform
scaling of the bitmap if required.

If the test (slevel >= rslevel) returns true, the bitmap should be scaled
to fit the area described by class member RECT StretchArea

Otherwise it should be blitted at 1:1 scale to the location (tx, ty)

*/
void C_bitmap::Blit(void)
{
}

/*

BeginDraw signifies that a load of drawing operations are about to begin, and
gives a chance to lock or acquire the bitmap if required on this target.

Result is true on success, false on failure

*/
bool C_bitmap::BeginDraw(void)
{
	return true;
}

/*

BeginDraw signifies that a load of reading operations are about to begin, and
gives a chance to lock or acquire the bitmap if required on this target.

Result is true on success, false on failure

*/
bool C_bitmap::BeginRead(void)
{
	return true;
}

/*

EndOperation is used to signify that reading or drawing is finished, and is
called after one of the two above functions

*/
void C_bitmap::EndOperation(void)
{
}

/*

GetLinePtr returns a pointer to the memory representing the scanline of pixels
located at line y. Returns NULL on error, a valid pointer otherwise.

This is only called inbetween a Begin??? and EndOperation pair

*/
unsigned __int8 *C_bitmap::GetLinePtr(int y)
{
	return NULL;
}

/*

A call to ReleaseLinePtr signifies that operations on the pointer last
returned by GetLinePtr are all done

*/
void C_bitmap::ReleaseLinePtr(void)
{
}

/*

GetDLinePtr is as GetLinePtr, except that it must provide a pointer at which
a first line of pixels may be written or read, and from which the line at
y+1 follows 'pitch' (a public class member) bytes later

*/
unsigned __int8 *C_bitmap::GetDLinePtr(int y)
{
	return NULL;
}

/*

as for ReleaseLinePtr, but to GetDLinePtr

*/
void C_bitmap::ReleaseDLinePtr(void)
{
}

#endif
