/*

	ElectrEm (c) 2000 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	gfx/null/platgfx.cpp
	====================

	The NULL graphics device

*/
#include "../../targets.h"
#ifdef TRG_GFX_NULL

/*

this is called by the real class constructor in order to achieve the usual
constructor sort of things for platform specific members

*/
void C_gfx_api::PlatformConstructor(void)
{
}

/*

Shutdown is to the platform destructor as Constructor is to the platform
constructor

*/
void C_gfx_api::PlatformShutdown(void)
{
}

/*

This fills a DSPSTRUCT such that its members width and height are equal to
the width and height of the first valid display window at least large enough
to display a bitmap of width w and h.

DSPSTRUCT may have additional platform specific members, and those should be
filled in as required here

*/
DSPSTRUCT C_gfx_api::GetGenuineSize(int w, int h)
{
}

/*

SetResolution sets the mode described by DSPSTRUCT, returning true on success
and false on failure

*/
bool C_gfx_api::SetResolution(DSPSTRUCT newsize)
{
	return true;
}

/*

PlatformSetup is called once at the start of the program if program startup
gets as far as requiring a graphics mode, and should do the usual library
initialisation. It is also passed the name of the application.

It should set the class member variable 'CursorRequired' to true if this
graphics driver is not going to draw a mouse cursor while the mouse is
required.

*/
bool C_gfx_api::PlatformSetup(char *appname)
{
	return true;
}

/*

This should set the palette pointed to by *cols (256 entries, but not
necessarily all used - see the header file for the definition)

*/
void C_gfx_api::PlatformSetPalette(colours *cols)
{
}

/*

This signifies that a palette as defined above has been filled in with the
required r, g and b values, and any preprocessing that is useful for this
target to do on palettes can be done now

*/
void C_gfx_api::PlatformFinishPalette(colours *cols)
{
}

/* Mouse stuff from here onwards */

/*

Enable mouse enables the mouse mode. If this target draws a cursor, it should
be enabled (if required) now

*/
void C_gfx_api::EnableMouse(void)
{
}

/*

DisableMouse is the opposite of EnableMouse, signifying that the mouse cursor
can be disabled

*/
void C_gfx_api::DisableMouse(void)
{
}

/*

GetMouseState should return the current location of the mouse cursor and the
state of its button.

The mouse location is relative to (backupscr.tx, backupscr.ty)

*/

MOUSE_STRUCT C_gfx_api::GetMouseState(void)
{
	MOUSE_STRUCT minfo;
	return minfo;
}

#endif