/*

	ElectrEm (c) 2000 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for details

	gfx/SVGALib/platbitmap.cpp
	==========================

	SVGALib bitmap class parts

*/
#include "../../targets.h"

#ifdef TRG_GFX_SVGALIB

#include "../gfx.h"
#include <malloc.h>

bool C_bitmap::Destroy(void)
{
	if(surface)
	{
		free(surface);
		surface = NULL;
	}

	return false;
}

bool C_bitmap::PlatformCreate(C_gfx_api *apiref, int w, int h, DSPSTRUCT intended, int pal)
{
	surface = (unsigned __int8 *)malloc(w*h);
	pitch = w;

	return true;
}

void C_bitmap::Blit(void)
{
	int c, pos, scy, addy, y;

	if(slevel >= rslevel)
	{
		c = StretchArea.bottom-StretchArea.top;
		addy = (height << 16) / c;
		scy = StretchArea.top;

		pos = 0;
		y = 0;
		while(c--)
		{
			vga_drawscansegment(&surface[pos], tx, scy, width);
			scy++;

			y += addy;
			if(y>> 16)
			{
				pos += pitch;
				y -= 65536;
			}
		}
	}
	else
	{
		scy = ty;
		c = height;

		pos = 0;
		while(c--)
		{
			vga_drawscansegment(&surface[pos], tx, scy, width);
			scy++;
			pos += pitch;
		}
	}
}

bool C_bitmap::BeginDraw(void)
{
	return true;
}

bool C_bitmap::BeginRead(void)
{
	return true;
}

void C_bitmap::EndOperation(void)
{
}

unsigned __int8 *C_bitmap::GetLinePtr(int y)
{
	return surface + (y*pitch);
}

void C_bitmap::ReleaseLinePtr(void)
{
}

unsigned __int8 *C_bitmap::GetDLinePtr(int y)
{
	return surface + (y*pitch);
}

void C_bitmap::ReleaseDLinePtr(void)
{
}

#endif
