#ifndef FILEMENU_H
#define FILEMENU_H

#include "guilocal.h"

class C_UEFChunkSelector;

/* this GUI element represents one file's display on the File menu. It is not
included in the header/source files of the other elements simply because it is
so specific to this menu screen */


/* this is the file menu screen */

class C_GUI;
class C_ULA;
class C_GUIFileElement;

class C_FileMenu : public C_GUIScreen
{
	public :
		bool Initialise(C_GUI *parent, int x1, int y1, int x2, int y2);
		void DeInitialise(void);

		void Enter(void);
		void Exit(void);

		void SendMsg(GUI_MSG msg);
		void Draw(void);

		void EvaluatePreload(void);

	private :
		void NewDir(void);
		void AttemptLoad(char *path, C_GUIFileElement *file);

		C_GUI *gui;
		C_ULA *elk;
		C_FSAccess *fs;

		C_GUIFileElement *files;
		int numfiles;
		C_GUIScrollField field;

		C_GUIFolderTabs tabs;

		GUI_BOX filearea;

		char *path;

		bool idone;
		int icount, icid;
};
#endif
