#ifndef GUI_H
#define GUI_H

#include "../types.h"

/* the message definitions */

enum GUI_MSGTYPE
{
	GUIM_NONE,

	GUIM_MOUSEMOVE,

	GUIM_LBUTTONDOWN,
	GUIM_LBUTTONUP,
	GUIM_LDCLICK,

	GUIM_KEYPRESS
};

struct GUI_MSG
{
	GUI_MSGTYPE msg;

	int x, y;
	unsigned char ch;
};

/* just enough for #include'ing */

class C_ULA;
class C_gfx_api;
class C_CardMenu;
class C_OpcodeErrorMenu;
class C_HaltOpcodeMenu;

enum GUI_STARTSCREEN
{
	GUISCR_DEFAULT,
	GUISCR_OPCODEERROR,
	GUISCR_HALT
};

#ifndef GUI_DSCRPTR
struct GUI_DSCRPTR;
#endif

class C_GUI
{
	public :
		C_GUI::C_GUI();

		bool Initialise(C_ULA *owner);
		void DeInitialise(void);

		void Go(GUI_STARTSCREEN screen);
		void SignalFinished(void);

		void SetDefault(GUI_DSCRPTR *desc);
		bool PreHandling(GUI_DSCRPTR *desc, GUI_MSG msg);

		C_gfx_api *GetPartialGFX(void);
		C_ULA *GetElectron(void);

		/* some bits that are passed to the GUI's kids */
		void EvaluatePreload(void);
		bool SetAutoId(unsigned __int8 id);
		void PassROMHint(bool set, int id, char *name);

	private :
		C_ULA *elk;
		C_gfx_api *gfx;

		void GenerateCols(int colid);

		bool done;
		bool button;
		int secs;

		C_CardMenu *MainGUI;
		C_OpcodeErrorMenu *OpcodeError;
		C_HaltOpcodeMenu *HaltOpcode;
};

#endif