/*

	ElectrEm (c) 2000/1 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	gui/msgstack.cpp
	================

	The functions here are inherited by all C_GUI things which wish to parse
	messages returned by GUI elements. That is - GUI screens and GUI elements
	which make use of other GUI elements (e.g. the slider and scroll bar -
	which both make use of the button)

*/
#include "guilocal.h"

void C_GUIMessageCollector::PushMessage(BACK_MSG msg)
{
	stack[sptr] = msg;
	sptr = (sptr-1)&31;
}

BACK_MSG C_GUIMessageCollector::PopMessage(void)
{
	sptr = (sptr+1)&31;
	return stack[sptr];
}

bool C_GUIMessageCollector::MessagesWaiting(void)
{
	return sptr != 0;
}

void C_GUIMessageCollector::InitialiseStack(void)
{
	sptr = 0;
}
