#ifndef OUTPUTMENU_H
#define OUTPUTMENU_H

#include "guilocal.h"

class C_ULA;
class C_input;

class C_GUIJoyDisplay : public C_GUIElementBase
{
	public :
		void Draw(void);

		void Setup(C_GUI *g, GUI_BOX area);
		void SetJoystick(int id);

	private :
		C_input *input;

		int joyid, hx, hy, w, h;
};

class C_OutputMenu : public C_GUIScreen
{
	public :
		bool Initialise(C_GUI *parent, int x1, int y1, int x2, int y2);

		void Enter(void);
		void Exit(void);

		void SendMsg(GUI_MSG msg);
		void Draw(void);

	private :
		C_GUI *gui;
		C_ULA *elk;

		//boxes and names - to divide the screen
		C_GUIOutlineBox boxes[2];
		C_GUITextBox names[2];

		//printer options
		C_GUITextBox filename, opthead;
		C_GUITextInputLine name;
		C_GUIRadioButton pbuts[5];
		C_GUIButton fset;
		char namestr[256];
		int pmode;

		//joystick options
		C_GUIJoyDisplay cwind;
		C_GUIFolderTabs joyselect;
		C_GUITextBox ctext;
		C_GUIButton calib, clr1, clr2, clrfb;
		C_GUITickBox joy1, joy2, fbjoy;
		C_GUISlider deadzone;
		int cjoy;
		void ResetJoystick(int njoy);
		void GetNextJoyPrompt(void);
		bool cal;
		int sticks;
};

#endif
