#ifndef ROMMENU_H
#define ROMMENU_H

#include "guilocal.h"
#include "../ula/ula.h"
#include "romclasses.h"

class C_GUI;
class C_GUIROMElement;
class C_GUIROMSlot;
struct FileTree;

class C_ROMMenu : public C_GUIScreen
{
	public :
		bool Initialise(C_GUI *parent, int x1, int y1, int x2, int y2);
		void DeInitialise(void);
		void ReSeed(void);
		bool SetAutoId(unsigned __int8 id);
		void PassROMHint(bool set, int id, char *name);

		void SendMsg(GUI_MSG msg);

	private :
		C_GUI *gui;
		C_ULA *elk;

		C_GUIScrollField romselector;
		C_GUIROMElement *roms, *def;
		int numroms;

		C_GUIROMSlot *slots;
		C_GUIButton empty, restore;
		int cslot;

		bool IsROM(unsigned __int8 *data);
		void GetROMName(unsigned __int8 *inrom, char *outname, int namelen);
		unsigned __int8 GetROMType(unsigned __int8 *inrom);
		bool SetRoms(bool dfs, bool adfs, bool persist, bool aload);
		bool FindAndAdd(char *name, int slot, bool complete);
		void LoadFromConfigFile(void);

		/* these store ROM hints */
		struct ExplicitROMHint
		{
			bool add;
			char *name;
		} ExplicitHints[256];
		int ExplicitId;

		bool ImplicitHints[NUM_ROMCLASSES];
		bool IgnoreReset;
};

#endif
