/*

	ElectrEm (c) 2000/1 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	misc/GII/platipt.cpp
	====================

	The [keyboard] input class - GII bits. Well, possibly GGI bits, I am
	confused.

*/
#include "../input.h"
#include "../../targets.h"

#ifdef TRG_IPT_GII

#include "../../defines.h"
#include <string.h>

void C_input::PlatformConstructor(void)
{
	qpos = lastpos = 0;
}

void C_input::PlatformDestructor(void)
{
}

bool C_input::PlatformSetup(void)
{
	memset(array, 0, MAX_KEY);

	/* only support 1 joystick */
	numsticks = 0;
/*	sticks = (JOY_INFO *)malloc(sizeof(JOY_INFO)*1);

	if(!(sticks[0].joy = giiOpen("linux-joy", NULL)))
		numsticks = 0;*/

	return true;
}

bool C_input::UpdateKeyStates(void)
{
	gii_event event;
	gii_event_mask mask;
	struct timeval t={0,0};

	/* with GII, must parse keyboard events */

	while(mask = ggiEventPoll(ggiVIS, emKey, &t))
	{
		ggiEventRead(ggiVIS, &event, emKey);

		if(event.key.button >= 0 && event.key.button < MAX_KEY)
		{
			if(event.any.type==evKeyPress)
			{
				/* set array entry to non zero */
				array[event.key.button] = 1;

				/* add ASCII code to the input buffer */
				aqueue[qpos] = event.key.sym;
				qpos = (qpos+1)&255;
			}
			if(event.any.type==evKeyRelease)
			{
				/* set array entry back to zero */
				array[event.key.button] = 0;
			}
		}
	}

	return true;
}

void C_input::UpdateLEDS(void)
{
	/* not sure about this */
}

void C_input::ClearBuffer(void)
{
	lastpos = qpos;
}

bool C_input::NewKey(void)
{
	return (qpos != lastpos) ? true : false;
}

unsigned char C_input::GetPressedASCII(void)
{
	unsigned char c;

	c = aqueue[lastpos];
	lastpos = (lastpos+1)&255;
	return c;
}

int C_input::PlatformGetNumKeys(void)
{
	return MAX_KEY;
}

/* joystick stuff, no joystick supported yet */

JOY_INFO C_input::GetJoystickInfo(int id)
{
	JOY_INFO f;

	f.analogue = true;
	f.calibrate = false;

	return f;
}

JOY_STATE C_input::PlatformGetJoystickState(int id)
{
	gii_event event;
	gii_event_mask mask;
	struct timeval t={0,0};

/*	while(mask = giiEventPoll(sticks[0].joy, emAll, &t))
	{
		giiEventRead(sticks[0].joy, &event, emValuator);
		fprintf(stderr, "valuator event\n");

		switch(event.any.type)
		{
			case evKeyPress :

				sticks[id].buttons |= (1 << event.key.button);

			break;

			case evKeyRelease :

				sticks[id].buttons &= ~(1 << event.key.button);

			break;

			case emValAbsolute :

				if(event.val.first == 0)
					sticks[id].s.x = event.val.value[0];

				if(event.val.first <= 1 && event.val.first+event.val.count >= 2)
					sticks[id].s.y = event.val.value[1];
			break;
		}
	}*/
/*	while(giiEventPoll(sticks[id].joy, emValAbsolute | emKeyPress | emKeyRelease, &t))
	{
		giiEventRead(sticks[id].joy, &event, emKey);

		switch(event.any.type)
		{
			case evKeyPress :

				sticks[id].buttons |= (1 << event.key.button);

			break;

			case evKeyRelease :

				sticks[id].buttons &= ~(1 << event.key.button);

			break;

			case emValAbsolute :

				if(event.val.first == 0)
					sticks[id].s.x = event.val.value[0];

				if(event.val.first <= 1 && event.val.first+event.val.count >= 2)
					sticks[id].s.y = event.val.value[1];
			break;
		}
	}*/

	return sticks[id].s;
}

void C_input::BeginCalibration(int id)
{
}

const char *C_input::GetJoystickInstruction(void)
{
	return NULL;
}

void C_input::FlagJoystickDone(void)
{
}

#endif
