/*

	ElectrEm (c) 2000/1 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	misc/null/platipt.cpp
	=====================

*/
#include "../input.h"
#include "../../targets.h"

#ifdef TRG_IPT_NULL

/*

a chance to implement the platform specific contructor requirements

*/
void C_input::PlatformConstructor(void)
{
}

/*

Destructor to the above Constructor

*/
void C_input::PlatformDestructor(void)
{
}

/*

Setup should set the numsticks value, and if necessary allocate and fill the
sticks array. It should also initialise the keyboard, and returns true or
false based on whether it successfully initialised that part only

*/
bool C_input::PlatformSetup(void)
{
	return true;
}

/*

UpdateKeyStates should update the 'array' class member with the current key
states, and provides an opportunity to poll joysticks if required

Returns true on success, false on failure

*/
bool C_input::UpdateKeyStates(void)
{
	return true;
}

/*

Offers a chance to alter the keyboard LEDs based on 'num' vs 'oldnum',
'caps' vs 'oldcaps' and 'scroll' vs 'oldscroll' if supported on this
platform

*/
void C_input::UpdateLEDS(void)
{
}

/*

ClearBuffer signifies that the ASCII buffer should be cleared

*/
void C_input::ClearBuffer(void)
{
}

/*

NewKey returns true if a new code awaits in the ASCII buffer

*/
bool C_input::NewKey(void)
{
	return false;
}

/*

GetPressedASCII returns the key at the top of the ASCII buffer. This is never
called unless NewKey returned true, and should provide '\n' if the enter
key has been pressed, and '\e' for escape

*/
unsigned char C_input::GetPressedASCII(void)
{
	return '\e';
}

/* joystick stuff */
/*

returns a JOY_INFO struct related to the 'id'th joystick

*/
JOY_INFO C_input::GetJoystickInfo(int id)
{
	return sticks[id];
}

/*

returns the current state of the 'id'th joystick, with x and y in the range
-128 to +128

*/
JOY_STATE C_input::PlatformGetJoystickState(int id)
{
	JOY_STATE state;

	return state;
}

/*

if a stick signalled that calibration was a possibility in its JOY_INFO struct
then this may at some time be called to signify that calibration is about
to be done on the stick

*/
void C_input::BeginCalibration(int id)
{
}

/*

this returns the current calibration instruction for the joystick signalled
last to BeginCalibration, or NULL if the calibration is finished

*/
const char *C_input::GetJoystickInstruction(void)
{
	return NULL;
}

/*

this is called when the user signals that the instruction last returned by
GetJoystickInstruction is being performed

*/
void C_input::FlagJoystickDone(void)
{
}

#endif
