/*

	ElectrEm (c) 2000/1 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	misc/null/timing.cpp
	====================

	The entire timer class is platform dependant!

*/
#include "../timing.h"
#include "../../targets.h"

#ifdef TRG_TMR_NULL

C_timer::C_timer(void)
{
}

C_timer::~C_timer(void)
{
}

/*

Calibrate is just a common private member, it needn't do anything if this
target doesn't want it to

*/
bool C_timer::Calibrate(int beats)
{
	return true;
}

/*

Get multiplier returns the current speed multiplier

*/
float C_timer::GetMultiplier(void)
{
	return mul;
}

/*

Set multiplier sets a new speed multipler

*/
void C_timer::SetMultiplier(float mult)
{
	mul = mult;
	if(mul)
		Calibrate((int)(mult*(float)standard));
}

/*

Resync is called to signify that the timer hasn't been called for a while,
but will be again soon

*/
void C_timer::Resync(void)
{
}

/*

sets how many times the RegisterBeat function will be called a second. With
the usual true/false return

*/
bool C_timer::SetBeatsPerSecond(int beats)
{
	mul = 1.0f;
	standard = beats;

	return Calibrate(beats);
}

/*

This should wait until the next beat is due then return

*/
void C_timer::RegisterBeat(void)
{
	if(!mul)
		return;

	current++;
	if(current >= subtotal)
	{
		current = 0;

		if(timevar > MULTIPLIER)
			error += timevar-MULTIPLIER;
		else
			while(timevar < MULTIPLIER);

		timevar -= MULTIPLIER;
	}
}

/*

returns true if the application hasn't been keeping up and is at least a
beat behind

*/
bool C_timer::FrameLate(void)
{
	if(error >= MULTIPLIER)
	{
		error -= MULTIPLIER;
		return true;
	}
	else
	{
		return false;
	}
}

#endif
