/*

	ElectrEm (c) 2000/1 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	misc/SDL/timing.cpp
	===================

	Handles the frame limiting and skipping for SDL

*/
#include "../timing.h"
#include "../../targets.h"

#ifdef TRG_TMR_SDL

bool skip;

C_timer::C_timer(void)
{
}

C_timer::~C_timer(void)
{
}

bool C_timer::Calibrate(int beats)
{
	aim = 1 << 8;

	if(beats > 50)
	{
		aim = (beats << 8) / 50;
		beats = 50;
	}

	add = (1000 << 8) / beats;

	Resync();

	return true;
}

float C_timer::GetMultiplier(void)
{
	return mul;
}

void C_timer::SetMultiplier(float mult)
{
	mul = mult;
	if(mul)
	{
		Calibrate((int)(mult*(float)standard));
		skip = false;
	}
	else
		skip = true;
}

bool C_timer::SetBeatsPerSecond(int beats)
{
	mul = 1.0f;
	standard = beats;
	skip = false;

	return Calibrate(beats);
}

void C_timer::Resync(void)
{
	target = (SDL_GetTicks() << 8) + add;
	subtotal = aim;
	errc = 0;
}

void C_timer::RegisterBeat(void)
{
	if(skip) return;

	subtotal -= 256;
	if(subtotal <= 0)
	{
		subtotal += aim;

		do
			current = SDL_GetTicks() << 8;
		while(current < target);

		error = current - target;
		target += add;
	}
}

bool C_timer::FrameLate(void)
{
	if(error > (add >> 1))
	{
		errc++;
		if(errc > 10)
			Resync();
		return true;
	}

	return false;
}

#endif