/*

	ElectrEm (c) 2000/1 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	misc/unix/parport.cpp
	=====================

	Sends the parallel port output to /dev/printer. I'm not sure how useful
	that approach is, since in UNIX printers are usually massive postscript
	things and as a result this code is currently only used by the
	SVGALib/Linux console build

*/
#include "../../targets.h"

#ifdef TRG_PARPORT_UNIX

#include "../input.h"
#include <unistd.h>
#include <fcntl.h>

void C_input::ParportSetup(void)
{
	port = -1;
}

bool C_input::ParportOpen(void)
{
	port = open("/dev/printer", O_WRONLY);
	return (port >= 0) ? true : false;
}

void C_input::ParportClose(void)
{
	if(port >= 0)
		close(port);
}

bool C_input::ParportFree(void)
{
	return true;
}

void C_input::ParportSend(unsigned __int8 v)
{
	if(port >= 0)
		write(port, &v, sizeof(unsigned __int8));
}

#endif
