/*
	ElectrEm (c) 2000/1 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	win32/parport.cpp
	=================

	I hate this code.

	This code communiicates directly with the Win32 print spooler in order
	to send characters straight to the default printer.

	Very nearly this entire file is based on code direct from MSDN.

*/
#include "../../targets.h"

#ifdef TRG_PARPORT_WIN32

#include "../input.h"

HANDLE C_input::hPrinter;
DOC_INFO_1 C_input::DocInfo;
DWORD C_input::dwJob;
void C_input::GetDefaultPrinter(void);
char *C_input::pname;
bool C_input::pr;

void C_input::ParportSetup(void)
{
	// get default printer name
	GetDefaultPrinter();
	if(!pname)
	{
		pr = false;
		return;
	}
}

bool C_input::ParportOpen(void)
{
	/* try to open the printer */
	if( ! OpenPrinter( pname, &hPrinter, NULL ) )
	{
		pr = false;
		return false;
	}

	// Fill in the structure with info about this "document."
	DocInfo.pDocName = "Acorn Electron output";
	DocInfo.pOutputFile = NULL;
	DocInfo.pDatatype = "RAW";

	// Inform the spooler the document is beginning.
	if( (dwJob = StartDocPrinter( hPrinter, 1, (unsigned char *)&DocInfo )) == 0 )
	{
		ClosePrinter( hPrinter );
		pr = false;
		return false;
	}

	// Start a page.
	if( ! StartPagePrinter( hPrinter ) )
	{
		EndDocPrinter( hPrinter );
		ClosePrinter( hPrinter );
		pr = false;
		return false;
	}

	pr = true;

	return pr;
}

void C_input::ParportClose(void)
{
	if(pr)
	{
		EndPagePrinter( hPrinter );
		EndDocPrinter( hPrinter );
		ClosePrinter( hPrinter );
		pr = false;
	}

	if(pname)
	{
		free(pname);
		pname = NULL;
	}
}

bool C_input::ParportFree(void)
{
//	EnumPrinters(PRINTER_ENUM_LOCAL, NULL, 2, pinfo, sizeof(PRINTER_INFO_2)*needed, &needed, &returned);
	return pr;
}

void C_input::ParportSend(unsigned __int8 v)
{
	DWORD dwBytesWritten;
	WritePrinter( hPrinter, &v, 1, &dwBytesWritten );
}

// Size of internal buffer used to hold "printername,drivername,portname"
// string. Increasing this may be necessary for huge strings.
#define MAXBUFFERSIZE 250

/* this is derived from example code from the MSDN */

void C_input::GetDefaultPrinter(void)
{
	OSVERSIONINFO osv;
	PRINTER_INFO_2 *ppi2 = NULL;
	DWORD dwNeeded = 0;
	DWORD dwReturned = 0;

	osv.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osv);
	pname = NULL;

	if (osv.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
	{
		EnumPrinters(PRINTER_ENUM_DEFAULT, NULL, 2, NULL, 0, &dwNeeded, &dwReturned);

		if (dwNeeded == 0) return;

		if(!(ppi2 = (PRINTER_INFO_2 *)malloc(sizeof(PRINTER_INFO_2)*dwNeeded))) return;

		// The second EnumPrinters() will fill in all the current information...
		if (!EnumPrinters(PRINTER_ENUM_DEFAULT, NULL, 2, (LPBYTE)ppi2, dwNeeded, &dwNeeded, &dwReturned))
		{
			free(ppi2);
			return;
		}

		pname = strdup(ppi2->pPrinterName);
	}
	else
		if (osv.dwPlatformId == VER_PLATFORM_WIN32_NT)
		{
			/* hope 1024 chars is big enough! */
			pname = (char *)malloc(1024);
			DWORD len = 1024;

#if(WINVER >= 0x0500)
			if (osv.dwMajorVersion >= 5) // Windows 2000 or later
			{
				bFlag = GetDefaultPrinter(pname, &len);
				
				if (!bFlag)
				{
					free(pname);
					pname = NULL;
					return;
				}
			}
			else
#endif
			{
				if (GetProfileString("windows", "device", ",,,", pname, len) <= 0)
				{
					free(pname);
					pname = NULL;
					return;
				}
				
				strtok(pname, ",");
			}
		}

	if (ppi2)
		free(ppi2);
}

#endif
