#ifndef CONFIG_H
#define CONFIG_H

#include <stdio.h>

enum set_types
{
	BOOLEAN_RESULT, INTEGER_RESULT, STRING_RESULT, ANY_RESULT, NO_RESULT
};

struct config_setting
{
	bool result_bool;
	int result_int;
	char *result_string;

	set_types result_type;
};

struct ConfigIndex
{
	struct ConfigIndex *next;

	char *title;
	config_setting value;
	bool freestr;
};

#ifndef C_FSAccess
class C_FSAccess;
#endif

class C_config
{
	public :
		C_config(void);
		~C_config(void);

		bool Open(char *name, C_FSAccess *own);
		void Close(void);

		bool FindSetting(char *name, set_types style);
		config_setting ReadSetting(void);
		void WriteSetting(struct config_setting setting);

	private :
		ConfigIndex *NewIndex(void);
 		void FreeIndex(void);
		void GetNewLine(FILE *f);
		void RollLeft(void);
		void DetermineType(char *arg);

 		ConfigIndex *list, *current;
		C_FSAccess *owner;
		bool found, dirty;

		char *req, *fname;
};

#endif
