#ifndef TIMING_H
#define TIMING_H

#include "../targets.h"

#ifdef TARGET_WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

#ifdef TRG_TMR_SDL
#include "SDL.h"
#endif

class C_timer
{
	public :
		C_timer(void);
		~C_timer(void);

		bool SetBeatsPerSecond(int beats);
		void RegisterBeat(void);
		float GetMultiplier(void);
		void SetMultiplier(float mult);
		void Resync(void);
		bool FrameLate(void);

	private :
		bool Calibrate(int beats);

		#if defined(TRG_TMR_ALLEGRO) || defined(TRG_TMR_POSIX)
			int subtotal, current, error, errc;
		#endif

		#ifdef TARGET_WIN32
			unsigned __int64 target, add;
			int subtotal, aim;
		#endif

		#ifdef TRG_TMR_SDL
			Uint32 target, add, error;
			Uint32 subtotal, aim;
			Uint32 current;
			int errc;
		#endif

		float mul;
		int standard;
		bool late;
};

#endif
