#ifndef PLUS1_H
#define PLUS1_H

#include "../types.h"
#include <stdio.h>

class C_ULA;
class C_input;
class C_FSAccess;

#define ACIAMODE_OFF		0
#define ACIAMODE_UART		1
#define ACIAMODE_SOCKETS	2

#define PRNMODE_OFF			0
#define PRNMODE_PARPORT		1
#define PRNMODE_ASCII		2
#define PRNMODE_ASCIILF		3
#define PRNMODE_RTF			4

class C_Plus1
{
	public :
		C_Plus1(void);
		~C_Plus1(void);

		bool Setup(C_ULA *);
		void Close(void);
		void MinimiseTimer(int);

		int *GetAddressList(void);

		void WriteTo(BrokenWord, unsigned __int8, unsigned __int32, int);
		void ReadFrom(BrokenWord, unsigned __int8 *, unsigned __int32 *, int);

		/* plus 1 specific parts */

		/* joystick [ADC] */
		void SetJoystick(int, int);
		int GetJoystick(int);

		/* printer */
		bool PRNSetFile(char *name);
		void PRNClose(void);

		void PRNSetMode(int);
		int PRNGetMode(void);
		int PRNGetCurrentMode(void);

		/* ACIA */
		void SetACIAMode(int);
		int GetACIAMode(void);
		bool QueryACIAMode(int);
		bool SetURL(char *url);

	private :
		C_ULA *ula;

		/* adc state variables */
		C_input *ipt;
		int ADCfintime;
		unsigned __int8 ADCresult;
		int joyid[2];

		int ADCGetChannel(int chan);
		unsigned __int8 ADCGetStatus(int time);

		/* printer state variables */
		C_FSAccess *fs;
		int PRNMode, PRNNextMode;
		FILE *PRNout;
		char *PRNfname;

		unsigned __int8 PRNGetStatus(int time);
		void PRNSendChar(char v);

		char PRNbuffer[128];
		int PRNbufpos;

		void PRNRollLeft(void);
		void PRNProcessToRTF(void);
};

#endif
