/*

	ElectrEm (c) 2000 Thomas Harte - an Acorn Electron Emulator

	This is open software, distributed under the GPL 2, see 'Copying' for
	details

	screen/common.cpp
	=================

	Contains the parts common to all screen drawing parts, wide and
	regular. Which isn't a great deal, but . . . 

*/
#include "common.h"
#include "../misc/timing.h"
#include "screen.h"

/* static class members */
int C_ScreenPels::y, C_ScreenPels::blank;

unsigned __int16 C_ScreenPelsCommon::MemMoves[32768];
bool C_ScreenPels::locked;
C_timer *C_ScreenPels::tmr;

ModeTable *C_ScreenPels::CTable, *C_ScreenPels::ATables;

int C_ScreenPels::LinePtr, C_ScreenPels::ScrMode, C_ScreenPels::c;
C_bitmap C_ScreenPels::img;

/* constructor */
C_ScreenPelsCommon::C_ScreenPelsCommon(void)
{
	int c = 32768;
	while(c--)
		MemMoves[c] = c+8;
}

/* routines */
void C_ScreenPelsCommon::InitDisplay(BrokenWord VidAddr)
{
	locked = false;
	c++;

	if(!tmr->FrameLate())
	{
		LinePtr = VidAddr.a ? VidAddr.a : 0x8000;

		if(img.BeginDraw())
		{
			y = 0; blank = 0;
			locked = true;
			c = 0;
		}
	}
}

void C_ScreenPelsCommon::EndDisplay(void)
{
	if(locked)
	{
		img.EndOperation();
		img.Blit();
	}
}

void C_ScreenPelsCommon::End(void)
{
	img.Destroy();
}

void C_ScreenPelsCommon::SaveImage(char *name)
{
	img.DumpToFile(name);
}

C_bitmap *C_ScreenPelsCommon::GetBitmap(void)
{
	return &img;
}

// the default function which achieves screen emulation as in previous betas
void C_ScreenPelsCommon::DrawMultiLine(int line, int *mchanges, int mchangecount, int *pchanges, int pchangecount)
{
	DrawPelLine(line);

	if(mchangecount)
	{
		mchanges += 1+((mchangecount-1) << 1);
		SetMode(*mchanges, line);
	}

	while(pchangecount--)
	{
		scr->AffectPalEntry(pchanges);
		pchanges += 3;
	}
}

