#ifndef SCREEN_REGULAR_PAL_H
#define SCREEN_REGULAR_PAL_H

#include "../screenloc.h"
#include "defs.h"

enum TableId
{
	Tab1B, Tab1W, Tab1N,
	Tab2B, Tab2W, Tab2N,
	Tab4B, Tab4N,

	TabNone
};

class C_ScreenPalModifierNormal : public C_ScreenPalModifier
{
	public :
		void Enable(BrokenQuad *cols);
		void Disable(void);

		void SetPalette(unsigned __int8 addr, unsigned __int8 val);
		void SyncPalette(void);
		void *SetMode(int mode);

	private :
		BrokenQuad *WCols;

		ConvElement *ColsTab1B, *ColsTab1W, *ColsTab1N;
		ConvElement *ColsTab2B, *ColsTab2W, *ColsTab2N;
		ConvElement *ColsTab4B, *ColsTab4N;

		bool sync;
		TableId tab;

		int vals[TabNone][8], set[8];
};

#endif
