#ifndef SCREENLOC_H
#define SCREENLOC_H

#include "../types.h"
#include "../gfx/gfx.h"
#include "screen.h"

#define PEL_START	16

class C_ULA;
class C_timer;
class C_screen;

typedef BrokenQuad WConvElement[256];

struct ModeTable
{
	bool spaced, wide;
	int pitch, bpp;
	int *TimeLine;
};

class C_ScreenPalModifier;

class C_ScreenPels
{
	public :
		virtual void DrawPelLine(int line) = 0;
		virtual void DrawMultiLine(int line, int *mchanges, int mcount, int *pchanges, int pcount) = 0;
		virtual void DrawBlankLine(int line, unsigned __int8 col0) = 0;

		virtual void InitDisplay(BrokenWord VidAddr) = 0;
		virtual void EndDisplay(void) = 0;

		virtual bool Setup(C_ULA *electron, DSPSTRUCT screen, ModeTable *tabs) = 0;
		virtual void End(void) = 0;

		virtual bool SetMode(unsigned __int8 newmode, int line) = 0;

		virtual void SaveImage(char *name) = 0;
		virtual C_bitmap *GetBitmap(void) = 0;

		static int y, blank;

	protected :
		static bool locked, modechange;
		static C_timer *tmr;

		static ModeTable *CTable, *ATables;

		static int LinePtr, ScrMode, c;
		static C_bitmap img;
};

class C_ScreenPalModifier
{
	public :
		virtual void Enable(BrokenQuad *cols) = 0;
		virtual void Disable(void) = 0;

		virtual void *SetMode(int mode) = 0;
		virtual void SetPalette(unsigned __int8 addr, unsigned __int8 val) = 0;
		virtual void SyncPalette(void) = 0;
};

#endif
