#ifndef SOUND_H
#define SOUND_H

#include "apibase.h"

class C_FSAccess;

#define SOUNDCARD_NAME "  card  "
#define SOUND_MASK		65535

class C_SoundProvider
{
	public :
		C_SoundProvider::C_SoundProvider();
		C_SoundProvider::~C_SoundProvider();

		void Setup(C_FSAccess *fs);
		void Close(void);
		void Keepalive(int time);

		C_SoundAPIBase *GetSoundSource(char *path, char *name, char *mode);
		void ReleaseSoundSource(C_SoundAPIBase *);

	private :
		struct SoundResource
		{
			SoundResource *next;
			char *path, *name, *mode;
			C_SoundAPIBase *resource;
			int references;
			bool freeable;
		} *list;

		SoundResource *NewListMember(void);
		void RemoveListMember(SoundResource *);

		C_FSAccess *fs;
};

#endif
