#ifndef SNDDEVS_H
#define SNDDEVS_H

#include "apibase.h"
#include "../targets.h"

#define TRG_SND_GLOBALS
#include TRG_SND_INCLUDE
#undef TRG_SND_GLOBALS

class C_SoundCard : public C_SoundAPIBase
{
	public :
		void Setup(void);
		void Close(void);

		void Keepalive(int clock);

#define SOUNDCARD_PUMEMBERS
#include TRG_SND_INCLUDE
#undef SOUNDCARD_PUMEMBERS

		C_SoundCard::C_SoundCard(void);

	private :

		void Pause(int time);
		void Unpause(int time);

#define SOUNDCARD_PRMEMBERS
#include TRG_SND_INCLUDE
#undef SOUNDCARD_PRMEMBERS

};

#include "../fs/fs.h"

class C_SoundFile : public C_SoundAPIBase
{
	public :
		void Setup(char *path, char *name, C_FSAccess *fs);
		void Close(void);

		void Keepalive(int clock);
		void MinimiseTimer(int sub);

		bool Control(int command, int value);

		C_SoundFile::C_SoundFile(void);

	private :
		void Pause(int time);
		void Unpause(int time);

		C_FSAccess *fs;
		gzFile File;
		unsigned int DataOffset, Pace, Incrementer;
		unsigned int Position, Length;
		int TimeBase;
		unsigned __int8 DataLatch;
		unsigned __int8 Sign;

		bool paused;
};

#endif
