#ifndef SPEAKER_H
#define SPEAKER_H

#include "../types.h"

#define SM_OFF	-1
#define	SM_ON	-2
#define SM_SINE	-3

#include "sound.h"

class C_Speaker
{
	public :
		C_Speaker(void);
		~C_Speaker(void);

		bool Setup(C_SoundProvider *snd, bool acc, float vol);
		void Close(void);

		void Keepalive(int time);
		void MinimiseTimer(int sub);

		void SetFrequency(int freq, int time);
		void DirectSetFrequency(int freq, int time);

		void SetMode(int mode, int time);
		void Resync(int time);

		void Pause(int time);
		void Unpause(int time);

		void SetVolume(float vol);
		float GetVolume(void);

		void SetAccuracy(bool on);
		bool GetAccuracy(void);

	private :

		float fvol;
		int volume;

		struct FreqChange
		{
			bool direct;
			int newval;
			int time;
		} *current, *start, all[2206];

		signed __int8 SquareWave[64];
		signed __int8 SineWave[64];
		signed __int8 Silence[64];
		signed __int8 HighPitch[2][64];

		signed __int8 *cwave, *lfwave;
		int lfwavelen;

		int basenum, bufpos, bufadd;

		inline void UpdatePointer(FreqChange **ptr);
		inline void ProcessEvent(FreqChange *cpos);

		bool accuracy;
		C_SoundProvider *snd;
		C_SoundAPIBase *card;
		SoundID outid;
};

#endif
