#ifndef TYPES_H
#define TYPES_H

#define CircularDifference(x, y, z) ((y <= x) ? (x-y) : (z+x-y))

#ifndef TARGET_WIN32

#ifndef __int8
#define __int8 char
#endif

#ifndef __int16
#define __int16 short
#endif

#ifndef __int32
#define __int32 int
#endif

#ifndef __int64
#define __int64 long long
#endif

#endif

#if !defined(ENDIAN_LITTLE) && !defined(ENDIAN_BIG)
#define GET_ENDIAN
#include "targets.h"
#endif

#ifdef ENDIAN_LITTLE

union BrokenWord
{
	unsigned __int16 a;

	struct
	{
		unsigned __int8 l, h;
	}b;
};

union BrokenQuad
{
	unsigned __int32 a;

	struct
	{
		unsigned __int8 b0, b1, b2, b3;
	}b;

	struct
	{
		BrokenWord w0, w1;
	}w;
};

#else

union BrokenWord
{
	unsigned __int16 a;

	struct
	{
		unsigned __int8 h, l;
	}b;
};

union BrokenQuad
{
	unsigned __int32 a;

	struct
	{
		unsigned __int8 b3, b2, b1, b0;
	}b;

	struct
	{
		BrokenWord w1, w0;
	}w;
};

#endif

#endif
