#ifndef DRIVE_H
#define DRIVE_H

#include "../uef/uef.h"

#ifndef C_ULA
class C_ULA;
#endif

enum FSTypes{
	FS_ADFS, FS_DBLADFS, FS_DFS, FS_DBLDFS, FS_NONE
};

class C_drive
{
	public :
		C_drive(C_ULA *elk);
		~C_drive(void);

		bool Open(char *path, char *name, unsigned __int8 id);
		bool New(char *path, char *name, unsigned __int8 id, FSTypes type);
		void Close(void);
		bool Useful(C_UEFChunkSelector *selector);

		void SetDir(bool inwards);
		bool GetDir(void);
		bool Step(void);
		bool SetTrack(int ntrack);
		int GetTrack(void);

		bool HasFile(void);
		void Flip(void);
		bool FirstSide(void);

		unsigned __int8 *GetSectorPtr(int snum, bool write);
		void ReleaseSectorPtr(int snum);

		bool GetWriteProtect(void);
		bool SetWriteProtect(bool protect);

		unsigned __int8 GetAutoloadID(void);

	private :
		bool LoadTraditional(bool, FSTypes);
		void SaveTraditional(void);
		void DeInterleave(int st);
		void ReInterleave(int st);
		bool GenerateNew(FSTypes);
		bool NewSide(FSTypes);
		bool OpenFile(char *path, char *name, unsigned __int8 id, bool neu, FSTypes type);

		C_UEFChunkSelector *disc;
		C_ULA *electron;

		char *path, *name;
		int Track, Trackadd;

		int Tracks, Sectors, SectorLength;
		bool FindSide(bool side1);

		int Len1, Len2, DataLen, flips;
		unsigned __int8 *Data1, *Data2, *Data;

		unsigned __int8 id;
		bool dirty, prot, fileprot, gz;
};

#endif
