#ifndef WD1770_H
#define WD1770_H

#include "../types.h"

enum wd1770_instruction{
	NONE,
	READ_SECTOR, READ_SECTOR_TRACK, WRITE_SECTOR,
	READ_TRACK, WRITE_TRACK, WRITE_SECTOR_TRACK
};

#ifndef C_ULA
class C_ULA;
#endif

class C_WD1770
{
	public :
		void Reset(void);
		void WriteToRegister(C_ULA *electron, int offset, unsigned __int8 value, int time);
		unsigned __int8 ReadFromRegister(C_ULA *electron, int offset, int time);

	private :
		unsigned __int8 regs[5], disk_id;
		int sector_position;
		wd1770_instruction instr;
		int sector, track;
};

#define STATUS	0
#define INSTR	0
#define TRACK	1
#define SECTOR	2
#define DATA	3
#define CONTROL	4

#define WD_M_FLAG	0x80
#define WD_W_FLAG	0x40
#define WD_S_FLAG	0x20
#define WD_R_FLAG	0x10
#define WD_C_FLAG	0x08
#define WD_Z_FLAG	0x04
#define WD_D_FLAG	0x02
#define WD_B_FLAG	0x01
#endif
